rc revision 88199
1#!/bin/sh
2#
3# Copyright (c) 2000  The FreeBSD Project
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10#    notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12#    notice, this list of conditions and the following disclaimer in the
13#    documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27#	@(#)rc	5.27 (Berkeley) 6/5/91
28# $FreeBSD: head/etc/rc 88199 2001-12-19 16:10:25Z brian $
29#
30
31# System startup script run by init on autoboot
32# or after single-user.
33# Output and error are redirected to console by init,
34# and the console is the controlling terminal.
35
36# Note that almost all of the user-configurable behavior is no longer in
37# this file, but rather in /etc/defaults/rc.conf.  Please check that file
38# first before contemplating any changes here.  If you do need to change
39# this file for some reason, we would like to know about it.
40
41stty status '^T'
42
43# Set shell to ignore SIGINT (2), but not children;
44# shell catches SIGQUIT (3) and returns to single user after fsck.
45#
46trap : 2
47trap : 3	# shouldn't be needed
48
49bootmode=$1
50
51HOME=/
52PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin
53export HOME PATH
54
55# BOOTP diskless boot.  We have to run the rc file early in order to
56# retarget various config files.
57#
58if [ -r /etc/rc.diskless1 ]; then
59	dlv=`/sbin/sysctl -n vfs.nfs.diskless_valid 2> /dev/null`
60	if [ ${dlv:=0} != 0 ]; then
61		. /etc/rc.diskless1
62	fi
63fi
64
65# If there is a global system configuration file, suck it in.
66#
67if [ -r /etc/defaults/rc.conf ]; then
68	. /etc/defaults/rc.conf
69	source_rc_confs
70elif [ -r /etc/rc.conf ]; then
71	. /etc/rc.conf
72fi
73
74feed_dev_random() {
75	if [ -f "${1}" -a -r "${1}" -a -s "${1}" ]; then
76#		echo "Using ${1} as an entropy file"
77		cat "${1}" | dd of=/dev/random bs=8k 2>/dev/null
78	fi
79}
80
81chkdepend() {
82	svc=$1
83	svc_var=$2
84	dep=$3
85	dep_var=$4
86
87	eval svc_val=\${$svc_var}
88	eval dep_val=\${$dep_var}
89
90	case ${svc_val} in
91	[Yy][Ee][Ss])
92		case ${dep_val} in
93		[Yy][Ee][Ss])
94		    ;;
95		*)
96		    eval ${dep_var}="YES"
97		    echo "DEPENDENCY NOTE: ${dep} will be enabled" \
98			 "to support ${svc}"
99		    ;;
100		esac
101		;;
102	esac
103}
104
105chkdepend amd amd_enable        portmap portmap_enable
106chkdepend NFS nfs_server_enable portmap portmap_enable
107chkdepend NIS nis_server_enable portmap portmap_enable
108chkdepend NIS nis_client_enable portmap portmap_enable
109
110# Enable harvesting of entropy via devices.  The sooner this happens the
111# better so that we can take advantage of the boot process.
112#
113echo -n 'Entropy harvesting:'
114
115case ${harvest_interrupt} in
116[Nn][Oo])
117	;;
118*)
119	if [ -w /dev/random ]; then
120		/sbin/sysctl kern.random.sys.harvest.interrupt=1 >/dev/null
121		echo -n ' interrupts'
122	fi
123	;;
124esac
125
126case ${harvest_ethernet} in
127[Nn][Oo])
128	;;
129*)
130	if [ -w /dev/random ]; then
131		/sbin/sysctl kern.random.sys.harvest.ethernet=1 >/dev/null
132		echo -n ' ethernet'
133	fi
134	;;
135esac
136
137case ${harvest_p_to_p} in
138[Nn][Oo])
139	;;
140*)
141	if [ -w /dev/random ]; then
142	/sbin/sysctl kern.random.sys.harvest.point_to_point=1 >/dev/null
143		echo -n ' point_to_point'
144	fi
145	;;
146esac
147
148echo '.'
149
150# First pass at reseeding /dev/random.
151#
152case ${entropy_file} in
153[Nn][Oo] | '')
154	;;
155*)
156	if [ -w /dev/random ]; then
157		feed_dev_random "${entropy_file}"
158	fi
159	;;
160esac
161
162# XXX temporary until we can get the entropy
163# harvesting rate up
164# Entropy below is not great,
165# but better than nothing.
166( ps -efauxww; sysctl -a; date; df -ib; dmesg; ps -efauxww; ) \
167    | dd of=/dev/random bs=8k 2>/dev/null
168cat /bin/ls | dd of=/dev/random bs=8k 2>/dev/null
169
170# Configure ccd devices.
171#
172if [ -r /etc/ccd.conf ]; then
173	ccdconfig -C
174fi
175
176case ${start_vinum} in
177[Yy][Ee][Ss])
178	vinum start
179	;;
180esac
181
182swapon -a
183
184# Last chance to do things before potentially waiting for
185# operator to do fsck related tasks
186if [ -r /etc/rc.early ]; then
187	. /etc/rc.early
188fi
189
190case ${bootmode} in
191autoboot)
192	echo 'Automatic boot in progress...'
193	case ${background_fsck} in
194	[Yy][Ee][Ss])
195		fsck -F -p
196		;;
197	*)
198		fsck -p
199		;;
200	esac
201	case $? in
202	0)
203		;;
204	2)
205		exit 1
206		;;
207	4)
208		reboot
209		echo 'Reboot failed... help!'
210		exit 1
211		;;
212	8)
213		case ${fsck_y_enable} in
214		[Yy][Ee][Ss])
215			echo 'File system preen failed, trying fsck -y . . .'
216			fsck -y
217			case $? in
218			0)
219				;;
220			*)
221			echo 'Automatic file system check failed . . . help!'
222				exit 1
223				;;
224			esac
225			;;
226		*)
227			echo 'Automatic file system check failed . . . help!'
228			exit 1
229			;;
230		esac
231		;;
232	12)
233		echo 'Reboot interrupted'
234		exit 1
235		;;
236	130)
237		# interrupt before catcher installed
238		exit 1
239		;;
240	*)
241		echo 'Unknown error in reboot'
242		exit 1
243		;;
244	esac
245	;;
246*)
247	echo 'Skipping disk checks ...'
248	;;
249esac
250
251set -T
252trap "echo 'Reboot interrupted'; exit 1" 3
253
254# root normally must be read/write, but if this is a BOOTP NFS
255# diskless boot it does not have to be.
256#
257case ${root_rw_mount} in
258[Nn][Oo] | '')
259	;;
260*)
261	if ! mount -u -o rw / ; then
262		echo 'Mounting root filesystem rw failed, startup aborted'
263		exit 1
264	fi
265	;;
266esac
267
268umount -a >/dev/null 2>&1
269
270# Mount everything except nfs filesystems.
271mount -a -t nonfs
272
273case $? in
2740)
275	;;
276*)
277	echo 'Mounting /etc/fstab filesystems failed, startup aborted'
278	exit 1
279	;;
280esac
281
282# Run custom disk mounting function here
283#
284if [ -n "${diskless_mount}" -a -r "${diskless_mount}" ]; then
285		sh ${diskless_mount}
286fi
287
288# Reseed /dev/random with previously stored entropy.
289case ${entropy_dir} in
290[Nn][Oo])
291	;;
292*)
293	entropy_dir=${entropy_dir:-/var/db/entropy}
294	if [ -d "${entropy_dir}" ]; then
295		if [ -w /dev/random ]; then
296			for seedfile in ${entropy_dir}/*; do
297				feed_dev_random "${seedfile}"
298			done
299		fi
300	fi
301	;;
302esac
303
304case ${entropy_file} in
305[Nn][Oo] | '')
306	;;
307*)
308	if [ -w /dev/random ]; then
309		feed_dev_random "${entropy_file}"
310	fi
311	;;
312esac
313
314adjkerntz -i
315
316purgedir() {
317	local dir file
318
319	if [ $# -eq 0 ]; then
320		purgedir .
321	else
322		for dir
323		do
324		(
325			cd "$dir" && for file in .* *
326			do
327				[ ."$file" = .. -o ."$file" = ... ] && continue
328				if [ -d "$file" -a ! -L "$file" ]
329				then
330					purgedir "$file"
331				else
332					rm -f -- "$file"
333				fi
334			done
335		)
336		done
337	fi
338}
339
340clean_var() {
341	if [ -d /var/run -a ! -f /var/run/clean_var ]; then
342		purgedir /var/run
343		# Keep a copy of the boot messages around
344		dmesg >/var/run/dmesg.boot
345		# And an initial utmp file
346		(cd /var/run && cp /dev/null utmp && chmod 644 utmp;)
347		>/var/run/clean_var
348	fi
349	if [ -d /var/spool/lock -a ! -f /var/spool/lock/clean_var ]; then
350		purgedir /var/spool/lock
351		>/var/spool/lock/clean_var
352	fi
353	rm -rf /var/spool/uucp/.Temp/*
354}
355
356# network_pass1() *may* end up writing stuff to /var - we don't want to
357# remove it immediately afterwards - *nor* do we want to fail to clean
358# an NFS-mounted /var.
359rm -f /var/run/clean_var /var/spool/lock/clean_var
360clean_var
361
362# Add additional swapfile, if configured.
363#
364case ${swapfile} in
365[Nn][Oo] | '')
366	;;
367*)
368	if [ -w "${swapfile}" -a -c /dev/mdctl ]; then
369		echo "Adding ${swapfile} as additional swap"
370		mdev=`mdconfig -a -t vnode -f ${swapfile}` && swapon /dev/${mdev}
371	fi
372	;;
373esac
374
375# Set sysctl variables as early as we can
376#
377if [ -r /etc/rc.sysctl ]; then
378	. /etc/rc.sysctl
379fi
380
381# Configure serial devices
382#
383if [ -r /etc/rc.serial ]; then
384	. /etc/rc.serial
385fi
386
387# Start up PC-card configuration
388#
389if [ -r /etc/rc.pccard ]; then
390	. /etc/rc.pccard
391fi
392
393# Start up the initial network configuration.
394#
395if [ -r /etc/rc.network ]; then
396	. /etc/rc.network	# We only need to do this once.
397	network_pass1
398fi
399
400case ${ipv6_enable} in
401[Yy][Ee][Ss])
402	if [ -r /etc/rc.network6 ]; then
403		. /etc/rc.network6	# We only need to do this once also.
404		network6_pass1
405	fi
406	;;
407esac
408
409# Mount NFS filesystems if present in /etc/fstab
410case "`mount -d -a -t nfs 2> /dev/null`" in
411*mount_nfs*)
412	# Handle absent nfs client support
413	nfsclient_in_kernel=0
414	if sysctl vfs.nfs >/dev/null 2>&1; then
415		nfsclient_in_kernel=1
416	else
417		kldload nfsclient && nfsclient_in_kernel=1
418	fi
419
420	case ${nfsclient_in_kernel} in
421	1)
422		echo -n 'Mounting NFS file systems:'
423		mount -a -t nfs
424		echo '.'
425		;;
426	*)
427		echo 'Warning: nfs mount requested, but no nfs client in kernel'
428		;;
429	esac
430	;;
431esac
432
433# Whack the pty perms back into shape.
434#
435if ls /dev/tty[pqrsPQRS]* > /dev/null 2>&1; then
436	chflags 0 /dev/tty[pqrsPQRS]*
437	chmod 666 /dev/tty[pqrsPQRS]*
438	chown root:wheel /dev/tty[pqrsPQRS]*
439fi
440
441# Clean up left-over files
442#
443clean_var			# If it hasn't already been done
444rm /var/run/clean_var /var/spool/lock/clean_var
445
446# Clearing /tmp at boot-time seems to have a long tradition.  It doesn't
447# help in any way for long-living systems, and it might accidentally
448# clobber files you would rather like to have preserved after a crash
449# (if not using mfs /tmp anyway).
450#
451# See also the example of another cleanup policy in /etc/periodic/daily.
452#
453case ${clear_tmp_enable} in
454[Yy][Ee][Ss])
455	echo -n 'Clearing /tmp:'
456	# prune quickly with one rm, then use find to clean up /tmp/[lq]*
457	# (not needed with mfs /tmp, but doesn't hurt there...)
458	(cd /tmp && rm -rf [a-km-pr-zA-Z]* &&
459		find -d . ! -name . ! -name lost+found ! -name quota.user \
460		! -name quota.group -exec rm -rf -- {} \;)
461	echo '.'
462	;;
463esac
464
465# Remove X lock files, since they will prevent you from restarting X11
466# after a system crash.
467#
468rm -f /tmp/.X*-lock /tmp/.X11-unix/*
469
470# Snapshot any kernel -c changes back to disk here <someday>.
471# This has changed with ELF and /kernel.config.
472
473echo -n 'Additional daemons:'
474
475# Start system logging and name service.  Named needs to start before syslogd
476# if you don't have a /etc/resolv.conf.
477#
478case ${syslogd_enable} in
479[Yy][Ee][Ss])
480	# Transitional symlink (for the next couple of years :) until all
481	# binaries have had a chance to move towards /var/run/log.
482	if [ ! -L /dev/log ]; then
483		# might complain for r/o root f/s
484		ln -sf /var/run/log /dev/log
485	fi
486
487	rm -f /var/run/log
488	echo -n ' syslogd';
489	${syslogd_program:-/usr/sbin/syslogd} ${syslogd_flags}
490	;;
491esac
492
493echo '.'
494
495# Build device name databases if we are not using DEVFS
496#
497if sysctl vfs.devfs.generation > /dev/null 2>&1 ; then
498	rm -f /var/run/dev.db
499else
500	dev_mkdb
501fi
502
503# Enable dumpdev so that savecore can see it.
504# /var/crash should be a directory or a symbolic link
505# to the crash directory if core dumps are to be saved.
506#
507case ${dumpdev} in
508[Nn][Oo] | '')
509	;;
510*)
511	case ${dumpdir} in
512	'')
513		dumpdir='/var/crash'
514		;;
515	esac
516
517	if [ -e "${dumpdev}" -a -d "${dumpdir}" ]; then
518		/sbin/dumpon -v ${dumpdev}
519		echo -n 'Checking for core dump: '
520		/sbin/savecore ${savecore_flags} "${dumpdir}"
521	fi
522	;;
523esac
524
525if [ -n "${network_pass1_done}" ]; then
526	network_pass2
527fi
528
529# Enable/Check the quotas (must be after ypbind if using NIS)
530#
531case ${enable_quotas} in
532[Yy][Ee][Ss])
533	case ${check_quotas} in
534	[Yy][Ee][Ss])
535		echo -n 'Checking quotas:'
536		quotacheck -a
537		echo ' done.'
538		;;
539	esac
540
541	echo -n 'Enabling quotas:'
542	quotaon -a
543	echo ' done.'
544	;;
545esac
546
547if [ -n "${network_pass2_done}" ]; then
548	network_pass3
549fi
550
551# Check the password temp/lock file
552#
553if [ -e /etc/ptmp ]; then
554	logger -s -p auth.err \
555	"password file may be incorrect -- /etc/ptmp exists"
556fi
557
558case ${accounting_enable} in
559[Yy][Ee][Ss])
560	if [ -d /var/account ]; then
561		echo 'Turning on accounting:'
562		if [ ! -e /var/account/acct ]; then
563			touch /var/account/acct
564		fi
565		accton /var/account/acct
566	fi
567	;;
568esac
569
570# Make shared lib searching a little faster.  Leave /usr/lib first if you
571# add your own entries or you may come to grief.
572#
573ldconfig="/sbin/ldconfig"
574case ${ldconfig_insecure} in
575[Yy][Ee][Ss])
576	ldconfig="${ldconfig} -i"
577	;;
578esac
579if [ -x /sbin/ldconfig ]; then
580	case `/usr/bin/objformat` in
581	elf)
582		_LDC=/usr/lib
583		for i in ${ldconfig_paths}; do
584			if [ -d "${i}" ]; then
585				_LDC="${_LDC} ${i}"
586			fi
587		done
588		echo 'ELF ldconfig path:' ${_LDC}
589		${ldconfig} -elf ${_LDC}
590		;;
591	esac
592
593	# Legacy aout support for i386 only
594	case `sysctl -n hw.machine` in
595	i386)
596		# Default the a.out ldconfig path.
597		: ${ldconfig_paths_aout=${ldconfig_paths}}
598		_LDC=/usr/lib/aout
599		for i in ${ldconfig_paths_aout}; do
600			if [ -d "${i}" ]; then
601				_LDC="${_LDC} ${i}"
602			fi
603		done
604		echo 'a.out ldconfig path:' ${_LDC}
605		${ldconfig} -aout ${_LDC}
606		;;
607	esac
608fi
609
610# Now start up miscellaneous daemons that don't belong anywhere else
611#
612echo -n 'Starting standard daemons:'
613case ${inetd_enable} in
614[Nn][Oo])
615	;;
616*)
617	echo -n ' inetd'; ${inetd_program:-/usr/sbin/inetd} ${inetd_flags}
618	;;
619esac
620
621case ${cron_enable} in
622[Nn][Oo])
623	;;
624*)
625	echo -n ' cron';	${cron_program:-/usr/sbin/cron} ${cron_flags}
626	;;
627esac
628
629case ${lpd_enable} in
630[Yy][Ee][Ss])
631	echo -n ' printer';	${lpd_program:-/usr/sbin/lpd} ${lpd_flags}
632	;;
633esac
634
635case ${sshd_enable} in
636[Yy][Ee][Ss])
637	if [ -x ${sshd_program:-/usr/sbin/sshd} ]; then
638		echo -n ' sshd';
639		${sshd_program:-/usr/sbin/sshd} ${sshd_flags}
640	fi
641	;;
642esac
643
644case ${usbd_enable} in
645[Yy][Ee][Ss])
646	echo -n ' usbd';	/usr/sbin/usbd ${usbd_flags}
647	;;
648esac
649
650if [ -r /etc/mail/sendmail.cf ]; then
651	case ${sendmail_enable} in
652	[Yy][Ee][Ss])
653		echo -n ' sendmail'
654		/usr/sbin/sendmail ${sendmail_flags}
655		;;
656	*)
657		case ${sendmail_outbound_enable} in
658		[Yy][Ee][Ss])
659			echo -n ' sendmail'
660			/usr/sbin/sendmail ${sendmail_outbound_flags}
661			;;
662		esac
663		;;
664	esac
665fi
666
667echo '.'
668
669# Recover vi editor files.
670find /var/tmp/vi.recover ! -type f -a ! -type d -delete
671vibackup=`echo /var/tmp/vi.recover/vi.*`
672if [ "${vibackup}" != '/var/tmp/vi.recover/vi.*' ]; then
673	echo -n 'Recovering vi editor sessions:'
674	for i in /var/tmp/vi.recover/vi.*; do
675		# Only test files that are readable.
676		if [ ! -r "${i}" ]; then
677			continue
678		fi
679
680		# Unmodified nvi editor backup files either have the
681		# execute bit set or are zero length.  Delete them.
682		if [ -x "${i}" -o ! -s "${i}" ]; then
683			rm -f "${i}"
684		fi
685	done
686
687	# It is possible to get incomplete recovery files, if the editor
688	# crashes at the right time.
689	virecovery=`echo /var/tmp/vi.recover/recover.*`
690	if [ "${virecovery}" != "/var/tmp/vi.recover/recover.*" ]; then
691		for i in /var/tmp/vi.recover/recover.*; do
692			# Only test files that are readable.
693			if [ ! -r "${i}" ]; then
694				continue
695			fi
696
697			# Delete any recovery files that are zero length,
698			# corrupted, or that have no corresponding backup file.
699			# Else send mail to the user.
700			recfile=`awk '/^X-vi-recover-path:/{print $2}' < "${i}"`
701			if [ -n "${recfile}" -a -s "${recfile}" ]; then
702				sendmail -t < "${i}"
703			else
704				rm -f "${i}"
705			fi
706		done
707	fi
708	echo '.'
709fi
710
711# Make a bounds file for msgs(1) if there isn't one already
712#
713if [ -d /var/msgs -a ! -f /var/msgs/bounds -a ! -L /var/msgs/bounds ]; then
714	echo 0 > /var/msgs/bounds
715fi
716
717case ${update_motd} in
718[Nn][Oo] | '')
719	;;
720*)
721	if T=`mktemp /tmp/_motd.XXXXXX`; then
722		uname -v | sed -e 's,^\([^#]*\) #\(.* [1-2][0-9][0-9][0-9]\).*/\([^\]*\) $,\1 (\3) #\2,' > ${T}
723		awk '{if (NR == 1) {if ($1 == "FreeBSD") {next} else {print "\n"$0}} else {print}}' < /etc/motd >> ${T}
724		cmp -s ${T} /etc/motd || {
725			cp ${T} /etc/motd
726			chmod 644 /etc/motd
727		}
728		rm -f ${T}
729	fi
730	;;
731esac
732
733# Run rc.devfs if readable to customize devfs
734#
735if [ -r /etc/rc.devfs ]; then
736	sh /etc/rc.devfs
737fi
738
739# Configure implementation specific stuff
740#
741arch=`uname -m`
742if [ -r /etc/rc.${arch} ]; then
743	. /etc/rc.${arch}
744fi
745
746# Configure the system console
747#
748if [ -r /etc/rc.syscons ]; then
749	. /etc/rc.syscons
750fi
751
752echo -n 'Additional ABI support:'
753
754# Load the SysV IPC API if requested.
755case ${sysvipc_enable} in
756[Yy][Ee][Ss])
757	echo -n ' sysvipc'
758	kldload sysvmsg >/dev/null 2>&1
759	kldload sysvsem >/dev/null 2>&1
760	kldload sysvshm >/dev/null 2>&1
761	;;
762esac
763
764# Start the Linux binary compatibility if requested.
765#
766case ${linux_enable} in
767[Yy][Ee][Ss])
768	echo -n ' linux'
769	if ! kldstat -v | grep -E 'linux(aout|elf)' > /dev/null; then
770		kldload linux > /dev/null 2>&1
771	fi
772	if [ -x /compat/linux/sbin/ldconfig ]; then
773		/compat/linux/sbin/ldconfig
774	fi
775	;;
776esac
777
778# Start the SysVR4 binary emulation if requested.
779#
780case ${svr4_enable} in
781[Yy][Ee][Ss])
782	echo -n ' svr4';	kldload svr4 > /dev/null 2>&1
783	;;
784esac
785
786echo '.'
787
788# Do traditional (but rather obsolete) rc.local file if it exists.  If you
789# use this file and want to make it programmatic, source /etc/defaults/rc.conf
790# in /etc/rc.local and add your custom variables to /etc/rc.conf, as
791# shown below.  Please do not put local extensions into /etc/rc itself.
792# Use /etc/rc.local
793#
794# ---- rc.local ----
795#	if [ -r /etc/defaults/rc.conf ]; then
796#		. /etc/defaults/rc.conf
797#		source_rc_confs
798#	elif [ -r /etc/rc.conf ]; then
799#		. /etc/rc.conf
800#	fi
801#
802#	... additional startup conditionals ...
803# ---- rc.local ----
804#
805if [ -r /etc/rc.local ]; then
806	echo -n 'Starting local daemons:'
807	sh /etc/rc.local
808	echo '.'
809fi
810
811# For each valid dir in $local_startup, search for init scripts matching *.sh
812#
813case ${local_startup} in
814[Nn][Oo] | '')
815	;;
816*)
817	echo -n 'Local package initialization:'
818	slist=""
819	if [ -z "${script_name_sep}" ]; then
820		script_name_sep=" "
821	fi
822	for dir in ${local_startup}; do
823		if [ -d "${dir}" ]; then
824			for script in ${dir}/*.sh; do
825				slist="${slist}${script_name_sep}${script}"
826			done
827		fi
828	done
829	script_save_sep="$IFS"
830	IFS="${script_name_sep}"
831	for script in ${slist}; do
832		if [ -x "${script}" ]; then
833			(set -T
834			trap 'exit 1' 2
835			${script} start)
836		elif [ -f "${script}" -o -L "${script}" ]; then
837			echo -n " (skipping ${script##*/}, not executable)"
838		fi
839	done
840	IFS="${script_save_sep}"
841	echo '.'
842	;;
843esac
844
845if [ -n "${network_pass3_done}" ]; then
846	network_pass4
847fi
848
849# Raise kernel security level.  This should be done only after `fsck' has
850# repaired local file systems if you want the securelevel to be greater than 1.
851#
852case ${kern_securelevel_enable} in
853[Yy][Ee][Ss])
854	if [ "${kern_securelevel}" -ge 0 ]; then
855		echo 'Raising kernel security level: '
856		sysctl kern.securelevel=${kern_securelevel}
857	fi
858	;;
859esac
860
861# Start background fsck checks if necessary
862case ${background_fsck} in
863[Yy][Ee][Ss])
864	echo 'Starting background filesystem checks'
865	nice -4 fsck -B -p 2>&1 | logger -p daemon.notice &
866	;;
867esac
868
869echo ''
870
871date
872
873exit 0
874
875